const chalk = require('chalk')
const format = require('util').format

var prefix = 'nos'
var sep = chalk.gray('.')

function log (color, args) {
  var msg = format.apply(format, args)
  console.log(chalk[color](prefix), sep, msg)
}

exports.log = function () {
  log('white', arguments)
}

exports.info = function () {
  log('blue', arguments)
}

exports.warn = function () {
  log('yellow', arguments)
}

exports.success = function () {
  log('green', arguments)
}

exports.error = function () {
  var msg = format.apply(format, arguments)
  console.log(chalk.red.underline(prefix), sep, msg)
  process.exit(1)
}
