/**
 * Created by hzlichaolin on 2016/7/15.
 * this module stop the multipart upload if it hasn't finish yet
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var encoder = require('../services/urlEncoder')

function abortMultipartUpload() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'DELETE', headers:{}
    };

    this.bucketName = null
    this.objectName = null

    this.uploadId = null
}

inherits(abortMultipartUpload,httpRequest)

abortMultipartUpload.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

abortMultipartUpload.prototype.setObjectName = function (objectName) {
    this.ObjectName = encoder(objectName)
}

abortMultipartUpload.prototype.setUploadId = function (uploadId) {
    this.uploadId = uploadId
}

abortMultipartUpload.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.bucketName + '/' + this.ObjectName + '?uploadId=' + this.uploadId
    this.options.headers['Date'] = (new Date()).toUTCString();
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = abortMultipartUpload;

