/**
 * Created by hzlichaolin on 2016/7/15.
 * you can finish a multipart upload when you use this module
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var xml2js = require('xml2js')
var crypto = require('crypto')
var encoder = require('../services/urlEncoder')

function completeMultipartUploadRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'POST', headers:{}
    };

    this.bucketName = null
    this.objectName = null
    this.objectMD5 = null
    this.partArray = null
    this.uploadId = null

    this.createRequestBody = function () {
        var json = {
            '':'',
            Part:this.partArray
        }

        var b = new xml2js.Builder()
        var xml = b.buildObject(json)
        xml = xml.replace('<root>','<CompleteMultipartUpload>').replace('</root>','</CompleteMultipartUpload>').replace('</>','')
        // console.log(xml)
        return xml
    }
}

inherits(completeMultipartUploadRequest,httpRequest)

completeMultipartUploadRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

completeMultipartUploadRequest.prototype.setObjectName = function (objectName) {
    this.objectName = encoder(objectName)
}

completeMultipartUploadRequest.prototype.setObjectMD5 = function (md5) {
    this.objectMD5 = md5
}

completeMultipartUploadRequest.prototype.setPartArray = function (partArray) {
    this.partArray = partArray
}

completeMultipartUploadRequest.prototype.setUploadId = function (uploadId) {
    this.uploadId = uploadId
}

completeMultipartUploadRequest.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.bucketName + '/' + this.objectName + '?uploadId=' + this.uploadId
    this.options.headers['Date'] = (new Date()).toUTCString();
    this.options.body = new Buffer(this.createRequestBody().toString())
    this.options.headers['Content-Length'] = this.options.body.length
    this.options.headers['Content-MD5'] = crypto.createHash('md5').update(this.options.body).digest('hex')
    if (this.objectMD5 != null){
        this.options.headers['x-nos-Object-md5'] = this.objectMD5
    }
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}



module.exports = completeMultipartUploadRequest;
