/**
 * Created by hzlichaolin on 2016/7/12.
 * you should create this object before getObject from nosproxy
 */
var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var encoder = require('../services/urlEncoder')

function getObjectRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'GET', headers:{}
    };

    this.bucketName = null
    this.objectName = null

    this.range = null
    this.ifModifiedSince = null
}

inherits(getObjectRequest,httpRequest)

getObjectRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

getObjectRequest.prototype.setObjectName = function (objectName) {
    this.objectName = encoder(objectName)
}

getObjectRequest.prototype.setRange = function (range) {
    this.range = range
}

getObjectRequest.prototype.setIfModifiedSince = function (ifModifiedSince) {
    this.ifModifiedSince = ifModifiedSince
}

getObjectRequest.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.bucketName + '/' + this.objectName
    this.options.headers['Date'] = (new Date()).toUTCString();
    if (this.range != null){
        this.options.headers['Range'] = this.range
    }
    if (this.ifModifiedSince != null){
        this.options.headers['If-Modified-Since'] = this.ifModifiedSince
    }
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = getObjectRequest;
