/**
 * Created by hzlichaolin on 2016/7/15.
 * you should use this first when you begin a multipart upload
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var encoder = require('../services/urlEncoder')

function initiateMultipartUploadRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'POST', headers:{}
    };

    this.bucketName = null
    this.objectName = null
    this.x_nos_storage_class = null
}

inherits(initiateMultipartUploadRequest,httpRequest)

initiateMultipartUploadRequest.prototype.setCustomMetaData = function (key, value) {
    this.options.headers[key] = value
}

initiateMultipartUploadRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

initiateMultipartUploadRequest.prototype.setObjectName = function (objectName) {
    this.objectName = encoder(objectName)
}

initiateMultipartUploadRequest.prototype.setStorageClass = function (storageClass) {
    this.x_nos_storage_class = storageClass
}

initiateMultipartUploadRequest.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.bucketName + '/' + this.objectName + '?uploads'
    this.options.headers['Date'] = (new Date()).toUTCString();
    if (this.x_nos_storage_class != null){
        this.options.headers['x-nos-storage-class'] = this.x_nos_storage_class
    }
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = initiateMultipartUploadRequest