/**
 * Created by hzlichaolin on 2016/7/15.
 * this module list all the multipart upload event in a bucket
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var querystring = require('querystring')


function listMultipartUploadRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'GET', headers:{}
    };

    this.bucketName = null
    this.keyMarker = null
    this.maxUploads = null
}

inherits(listMultipartUploadRequest,httpRequest)

listMultipartUploadRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

listMultipartUploadRequest.prototype.setKeyMarker = function (keyMarker) {
    this.keyMarker = keyMarker
}

listMultipartUploadRequest.prototype.setMaxUploads = function (maxUploads) {
    this.maxUploads = maxUploads
}

listMultipartUploadRequest.prototype.sendRequest = function (func) {

    var para = {}
    if (this.keyMarker != null){
        para['key-marker'] = this.keyMarker
    }
    if (this.maxUploads != null){
        para['max-uploads'] = this.maxUploads
    }
    var query = querystring.stringify(para)
    
    if (query.length > 0){
        query = '&' + query
    }

    var resource = '/' + this.bucketName + '/?uploads'
    this.options.path = '/' + this.bucketName + '/?uploads' + query
    this.options.headers['Date'] = (new Date()).toUTCString();
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,resource)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = listMultipartUploadRequest
