/**
 * Created by hzlichaolin on 2016/7/15.
 * this module show multipart upload situation
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var querystring = require('querystring')
var encoder = require('../services/urlEncoder')

function listPartsRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'GET', headers:{}
    };

    this.bucketName = null
    this.objectName = null
    this.uploadId = null
    this.max_parts = null
    this.part_number_marker = null
}

inherits(listPartsRequest,httpRequest)

listPartsRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

listPartsRequest.prototype.setObjectName = function (objectName) {
    this.objectName = encoder(objectName)
}

listPartsRequest.prototype.setUploadId = function (uploadId) {
    this.uploadId = uploadId
}

listPartsRequest.prototype.setMaxParts = function (maxParts) {
    this.max_parts = maxParts
}

listPartsRequest.prototype.setPartNumberMarker = function (partNumberMarker) {
    this.part_number_marker = partNumberMarker
}

listPartsRequest.prototype.sendRequest = function (func) {

    var para = {}
    if (this.uploadId != null){
        para['uploadId'] = this.uploadId
    }
    if (this.max_parts != null){
        para['max-parts'] = this.max_parts
    }
    if (this.part_number_marker != null){
        para['part-number-marker	'] = this.part_number_marker
    }
    var query = querystring.stringify(para)

    if (query.length > 0){
        query = '?'+query
    }

    var resource = '/' + this.bucketName + '/' + this.objectName + '?uploadId=' + this.uploadId
    this.options.path = '/' + this.bucketName + '/' +this.objectName + query
    this.options.headers['Date'] = (new Date()).toUTCString();
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,resource)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = listPartsRequest
