/**
 * Created by hzlichaolin on 2016/7/15.
 * this module let you upload a part of a big object
 */
var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var crypto = require('crypto')
var querystring = require('querystring')
var encoder = require('../services/urlEncoder')

function uploadPartRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'PUT', headers:{}
    };

    this.bucketName = null
    this.objectName = null
    this.partNumber = null
    this.uploadId = null
    this.expect = null
    this.body = null
}

inherits(uploadPartRequest,httpRequest)

uploadPartRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

uploadPartRequest.prototype.setObjectName = function (objectName) {
    this.ObjectName = encoder(objectName)
}

uploadPartRequest.prototype.setPartNumber = function (partNumber) {
    this.partNumber = partNumber
}

uploadPartRequest.prototype.setUploadId = function (uploadId) {
    this.uploadId = uploadId
}

uploadPartRequest.prototype.setBody = function (body) {
    this.body = body
}

uploadPartRequest.prototype.setExpect = function (expect) {
    this.expect = expect
}

uploadPartRequest.prototype.sendRequest = function (func) {

    var para = {}
    if (this.partNumber != null){
        para['partNumber'] = this.partNumber
    }
    if (this.uploadId != null){
        para['uploadId'] = this.uploadId
    }
    var query = querystring.stringify(para)

    if (query.length > 0){
        query = '?'+query
    }

    this.options.path = '/' + this.bucketName + '/' + this.ObjectName +query
    this.options.headers['Date'] = (new Date()).toUTCString();
    this.options.body = this.body
    this.options.headers['Content-Length'] = this.body.length
    this.options.headers['Content-MD5'] = crypto.createHash('md5').update(this.options.body).digest('hex')
    if (this.expect != null){
        this.options.headers['Expect'] = this.expect
    }
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = uploadPartRequest
