/**
 * Created by hzlichaolin on 2016/7/20.
 */

var NOSClient = require('../index')
var xml2js = require('xml2js')
var parser = new xml2js.Parser();
var expect = require('chai').expect;
var client = new NOSClient()
client.setAccessId('accessId')
client.setSecretKey('secretKey')
client.setHost('localhost')
client.setPort('8500')

describe('abort_multipart_upload test', function() {

    var statusCode = null
    var uploadId = null

    var func = function (res) {
        //only for get_object test, so it's ok to be empty here
    }

    beforeEach(function(done) {

        client.create_multipart_upload({
            bucket:'bucket',
            key:'d.txt',
            meta_data:{'x-nos-meta-hell':'hello'}},function (res) {

            res.setEncoding('utf8');
            res.on('data', function(chunk){
                parser.parseString(chunk,function (err, result) {
                    uploadId = result['InitiateMultipartUploadResult']['UploadId'][0]
                })
            });
        })

        setTimeout(function() {
            done()
        }, 1000);
    });

    it('it should be 200', function(done) {

        client.abort_multipart_upload({
            bucket:'bucket',
            key:'d.txt',
            upload_id:uploadId},function (res) {
            statusCode = res.statusCode
        })

        setTimeout(function() {
            expect(statusCode).to.be.equal(200);
            done()
        }, 1000);
    });
});
